
#include <GL/glut.h>
#include <stdio.h>

void Render( void )
{
    glClear( GL_COLOR_BUFFER_BIT );
    glutSwapBuffers();
}

void Reshape( int width, int height )
{
}

void Write( FILE* file, const char* text )
{
    fwrite( text, 1, strlen(text), file );
}

int main( int argc, char* argv[] )
{
    FILE* file = NULL;
    const char* extensions = NULL;

    // Initialize
    glutInit( &argc, argv );
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
    glutCreateWindow( "OpenGL Info" );
    glutDisplayFunc( Render );
    glutReshapeFunc( Reshape );

    // Create file for dumping
    file = fopen( "devcaps.txt", "w+" );
    if ( file == NULL ) {
	printf( "Cannot create file devcaps.txt\n" );
	return 1;
    }

    // Enumerate extensions
    Write( file, "D3DVERSION\t\t\t\t\tOPENGL\n" );
    Write( file, "BEGIN\t\t\t\t\t\tGLINFO\n" );
    Write( file, "    VENDOR\t\t\t\t\t" ); Write( file, (const char*)glGetString( GL_VENDOR ) ); Write( file, "\n" );
    Write( file, "    RENDERER\t\t\t\t\t" ); Write( file, (const char*)glGetString( GL_RENDERER ) ); Write( file, "\n" );
    Write( file, "    VERSION\t\t\t\t\t" ); Write( file, (const char*)glGetString( GL_VERSION ) ); Write( file, "\n" );
    Write( file, "END\t\t\t\t\t\tGLINFO\n" );
    Write( file, "BEGIN\t\t\t\t\t\tEXTENSIONS\n" );
    extensions = (const char*)glGetString( GL_EXTENSIONS );
    while ( *extensions != '\0' ) {
	const char* begin = extensions;
	int i;

	while ( (*extensions != '\0') && (*extensions != ' ') ) {
	    ++extensions;
	}
	Write( file, "    GL\t\t\t\t\t\t" );
	fwrite( begin, 1, extensions-begin, file );
	Write( file, "\n" );
	if ( *extensions != '\0' ) {
	    ++extensions;
	}
    }
    Write( file, "END\t\t\t\t\t\tEXTENSIONS\n" );

    // Close file
    fclose( file );

    // Main loop
    //glutMainLoop();
    return 0;
}
