
class Output {
    HANDLE file;
    int indent;
public:
    Output( const char* filename );
    ~Output();
    bool Write( const char* s1, const char* s2 );
    bool Write( const char* s1, unsigned i );
    bool Error( const char* s2 );
    void IncrementIndent() { ++indent; }
    void DecrementIndent() { --indent; }
    bool CheckError( const char* fun, int error_code );
private:
    bool WriteRaw( const char* s, unsigned size );
};

class Section {
    Output& output;
    const char* const section_name;
public:
    Section( Output& output, const char* section_name );
    ~Section();
};

#define SECTION( name ) Section _sec_( output, name )